//+------------------------------------------------------------------+
//|                                                          ATR.mq4 |
//|                                                    Howard Joseph |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Howard Joseph"
#property link      "howard.joseph@gmail.com"

//---- input parameters
extern double    Lots=0.1;
extern int       Start_Check=0;
extern int       ATR_Period=20;
extern int       ATR_Minimum=10;
extern int       Max_Slippage=10;
extern int       Bar_Period=1440;
extern int       Bar_Offset=1;
extern double    TP_Multiplier=1.0;
extern int       TP_Offset=0;
extern double    Open_Multiplier=0.5;
extern int       Open_Offset=0;
extern double    SL_Multiplier=0.0;
extern int       SL_Offset=0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
bool NewBar() //Code to discover if new bar has been created
  {
   static datetime lastbar = 0;
   datetime curbar = Time[0];
   if(lastbar!=curbar)
     {
      lastbar=curbar;
      return(true);
     }
   else
     {
      return(false);
     }
   return(0);
  }
int start()
  {
   double ATR_Value;
   if (NewBar() == true) //Code to test if NewBar check is valid, to initiate order manageme
     {
      if (Start_Check < 1)
        {
         Start_Check = (Start_Check + 1);
         Print("Start Bar ",iOpen(NULL,0,0)); //Displays open of bar currently loaded when adding EA or loading MT4
         return(0);
        }
      Print("New Bar ",iOpen(NULL,0,0)); //Displays that a New Bar has been formed, with its open price
      string curr = Symbol(); //Code to cancel all open positions on current pair
      int ot = OrdersTotal();
      int ords[200], ordType[200], ordTicket[200]; double ordLots[200];
      string ordComments[200];
      int ix=0;
      for (int i=0; i<ot; i++)
        {
         int o = OrderSelect(i, SELECT_BY_POS);
         if (OrderSymbol() == Symbol())
         if ((OrderType() == OP_BUY) || (OrderType() == OP_SELL))
           {
            ords[ix] = o; ordType[ix] = OrderType(); 
            ordLots[ix] = OrderLots(); ordTicket[ix] = OrderTicket();
            ordComments[ix] = OrderComment();
            ix++;
           }
        }
      for (i=0; i<ix; i++)
        {
         double ask = MarketInfo(Symbol(), MODE_ASK);
         double bid = MarketInfo(Symbol(), MODE_BID);
         double prc = 0;
         if (ordType[i] == OP_BUY) prc = bid; else prc=ask;
         OrderSelect(ords[i], SELECT_BY_POS);
         OrderClose(ordTicket[i], ordLots[i],prc,5);
         Print("Info ",GetLastError());
        }
      ATR_Value = iATR(NULL,0,ATR_Period,0); //Get current ATR Value from chart
      if (ATR_Value < (ATR_Minimum*Point)) //Check current ATR_Value to ensure it is no less than the ATR_Minimum set
        {
         Print("Too little range for trading.   ATR_Minimum ",(ATR_Minimum*Point),"   ATR_Value ",ATR_Value);
         return(0);
        }
      
      double buyopen,nbuyopen,buysl,nbuysl,buytp,nbuytp,sellopen,nsellopen,sellsl,nsellsl,selltp,nselltp;
      buyopen=((iOpen(NULL,0,0))+(ATR_Value*Open_Multiplier)+Open_Offset);
      nbuyopen=NormalizeDouble(buyopen,Digits);
      buysl=((iOpen(NULL,0,0))+(ATR_Value*SL_Multiplier)+SL_Offset);
      nbuysl=NormalizeDouble(buysl,Digits);
      buytp=((iOpen(NULL,0,0))+(ATR_Value*TP_Multiplier)+TP_Offset);
      nbuytp=NormalizeDouble(buytp,Digits);
      sellopen=((iOpen(NULL,0,0))-(ATR_Value*Open_Multiplier)-Open_Offset);
      nsellopen=NormalizeDouble(sellopen,Digits);
      sellsl=((iOpen(NULL,0,0))-(ATR_Value*SL_Multiplier)-SL_Offset);
      nsellsl=NormalizeDouble(sellsl,Digits);
      selltp=((iOpen(NULL,0,0))-(ATR_Value*TP_Multiplier)-TP_Offset);
      nselltp=NormalizeDouble(sellsl,Digits);
      Print("Open:",nbuyopen," TP:",nbuytp," SL:",nbuysl);
      
      int ticketbuy;
      ticketbuy=OrderSend(Symbol(),OP_BUYSTOP,Lots,nbuyopen,Max_Slippage,nbuysl,nbuytp,"Buy Order",12345,(Bar_Period-Bar_Offset),Green);
      if(ticketbuy<0)
        {
         Print("Buy Order failed with error #",GetLastError());
         return(0);
        }
      int ticketsell;
      ticketsell=OrderSend(Symbol(),OP_SELLSTOP,Lots,nsellopen,Max_Slippage,nsellsl,nselltp,"Buy Order",54321,(Bar_Period-Bar_Offset),Red);
      if(ticketsell<0)
        {
         Print("Buy Order failed with error #",GetLastError());
         return(0);
        }
     }
   return(0);
  }
//+------------------------------------------------------------------+